// This file is part of PUMA.
// Copyright (C) 1999-2015  The PUMA developer team.
//                                                                
// This program is free software;  you can redistribute it and/or 
// modify it under the terms of the GNU General Public License as 
// published by the Free Software Foundation; either version 2 of 
// the License, or (at your option) any later version.            
//                                                                
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of 
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the  
// GNU General Public License for more details.                   
//                                                                
// You should have received a copy of the GNU General Public      
// License along with this program; if not, write to the Free     
// Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
// MA  02111-1307  USA                                            

#ifndef PUMA_Pipe_H
#define PUMA_Pipe_H

/** \file
 * Input/output pipe implementation. */

#include "Puma/Source.h"
#include "Puma/Sink.h"

namespace Puma {

/** \class Pipe Pipe.h Puma/Pipe.h
 * Pipe between an input source and an output sink.
 * \warning This class is not used and may disappear without notice. 
 * \ingroup basics */
class Pipe : public Source, public Sink {
  char *m_buffer;
  char *m_rpos;
  char *m_wpos;
  int m_size;
  bool m_empty;

public:
  Pipe(int buffer_size);
  ~Pipe();
  int read(char *dest, int n);
  int write(const char *dest, int n);
  int free();
  bool full() {
    return free() == 0;
  }
  void dump();
};

} // namespace Puma

#endif /* PUMA_Pipe_H */
